#include <string.h>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>

struct timeval TInfo;
long Sec;
char RawData[4000];

extern int FillRawData(void);

extern char *TimeString(void);

extern int GetVariable(const char *, char *);


extern char *TimeString(void)

{
 char Buf[30];
 char *DtString;
 
 gettimeofday(&TInfo);
 Sec=TInfo.tv_sec;
 DtString=ctime_r(&Sec,Buf,30);
 return DtString;
}


extern int FillRawData(void)

{
int Length;

Length=atoi(getenv("CONTENT_LENGTH"));

fgets(RawData,Length+1,stdin);  
RawData[Length]='&';
RawData[Length+1]='\0';
return Length;
}


extern int GetVariable(const char *Variable, char *Val)

{

char *VarPointer,Ch,HexCode[2];
int  VarLength, Marker=0,IntCode;
long LongCode;


VarPointer=strstr(RawData,Variable);
if (VarPointer); else return -1;

VarLength=strlen(Variable);

 while ( *(VarPointer+VarLength+Marker) != '&')
   {
    Ch=*(VarPointer+VarLength+Marker);
     
     switch (Ch) {

      case '+': *(Val+Marker)=' ';
                break;
      
      case '%': HexCode[0]= *(VarPointer+VarLength+Marker+1);
                HexCode[1]= *(VarPointer+VarLength+Marker+2);
                HexCode[2]='\0';
                LongCode=strtol(HexCode, NULL, 16);
                IntCode=(int)LongCode;
                *(Val+Marker)=(char)IntCode;

                VarLength=VarLength+2;
                break;

      default : *(Val+Marker) = *(VarPointer+VarLength+Marker);
                break;
                }
     Marker++;
   }

 *(Val+Marker)='\0';

return 0;
}
